100 rem $$asmb=win1_uti_spr_Spr2RLE_bin,0,10
102 :
104 rem + ------------------------------------------------------------------------ +
106 rem |<                                Spr2RLE                                 >|
108 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
110 rem |                  Compress a simple, single GD2 sprite                    |
112 rem |                                                                          |
114 rem |              PRINT FEW(<path>Spr2RLE; '<input file name>')               |
116 rem | or                                                                       |
118 rem |                                                                          |
120 rem | PRINT FEW(<path>Spr2RLE; '/F"<input file name>" [/O<output file name>]') |
122 rem |                                                                          |
124 rem | If no output file name given result overwrites ram1_sprite_spr           |
126 rem |                                                                          |
128 rem | With either just a pattern or a mask, or both.                           |
130 rem | Assumes sprite is made in a regular/standard way, without sprite, block, |
132 rem | options or chained sprites. If any part of the sprite is already         |
134 rem | compressed it gives up.                                                  |
136 rem |                                                                          |
138 rem | Dependencies: BTST%; tks ENRLE, EVEN, DETAB$                             |
140 rem + ------------------------------------------------------------------------ +
142 rem | V0.01, pjw, 2019 Jun 10                                                  |
144 rem | V0.02, pjw, 2024 Sep 02, debugged and much improved                      |
146 rem + ------------------------------------------------------------------------ +
148 :
150 :
152 ext_fn 'ENRLE', 'EVEN', 'DETAB$'
154 :
156 quote$  = '"' & "'"
158 spr = GetCmd(CMD$)
160 if spr < 0: quit er
162 :
164 fl = flen(#spr): close#spr
166 spr = alchp(fl + fl + 16)
168 tsp = spr + fl:                         rem New sprite address..
170 lbytes ifn$, spr:                       rem ..in top half of buffer
172 :
174 ctr%   = peek(spr + 3):                 rem Control byte
176 :
178 rem     Weed out stuff we dont handle
180 if peek(spr) <> 2: Tidy -19:            rem GD2 only
182 if BTST%(ctr%, 7) or BTST%(ctr%, 6): Tidy -8:  rem Some data was already compressed
184 if BTST%(ctr%, 4) or BTST%(ctr%, 2): Tidy -19: rem Cant handle Options or Sprite Block
186 if peek_l(spr + 20): Tidy -14:          rem No chained sprites
188 :
190 hdsz = 24:                              rem Header size of simple sprite
192 md%   = peek(spr + 1):                  rem Colour mode
194 sel on md%
196  = 16: rlesz = 1
198  = 32, 33: rlesz = 2:                   rem Work out blob's RLE element size
200  = 64: rlesz = 4
202  = remainder: Tidy -19:                 rem We only handle these sprites
204 endsel
206 sx = peek_w(spr + 4):                   rem X size
208 sy = peek_w(spr + 6):                   rem Y-size
210 :
212 rem     Get pattern (if any)
214 if peek_l(spr + 12) then
216  patadr = spr + peek_l(spr + 12) + 12:  rem Abs addr of pattern data
218 else
220  patadr = 0
222 endif
224 :
226 rem     Get mask (if any)
228 if peek_l(spr + 16) then
230  mskadr = spr + peek_l(spr + 16) + 16:  rem Abs addr of mask data
232  alpha  = ctr% && 32:                   rem alpha <> 0 if alpha
234 else
236  mskadr = 0: alpha = 0
238 endif
240 :
242 rem     Calculate data size
244 patsz  = 4 * int((sx * rlesz + 3) / 4) * sy: rem Data size, rounded to nearest long
246 patsz  = EVEN(patsz):                   rem Round up to even
248 if not alpha then
250  msksz = patsz:                         rem Mask size same as pattern..
252 else
254  msksz = EVEN(sx * sy):                 rem ..unless alpha
256 endif
258 npsz   = 0:                             rem New pattern size
260 nmsz   = 0:                             rem New mask size
262 :
264 rem     Do it!
266 rlex  = 0:                              rem Extra room for RLE header(s)
268 if patadr then
270  npsz = ENRLE(patadr, tsp + hdsz + 8, patsz, rlesz): rem New pattern size
272  if npsz < 0: Tidy npsz:                rem Doesnt compress
274  :
276  poke$ tsp + hdsz, 'RLE' & rlesz:       rem Set RLE header
278  poke_l tsp + hdsz + 4, patsz
280  ctr% = ctr% || 64:                     rem Flag pattern compressed
282  rlex = 8:                              rem This much added to data
284 endif
286 :
288 nxadr = tsp + hdsz + npsz + rlex:       rem Next address
290 if mskadr then
292  if alpha then
294   nmsz  = ENRLE(mskadr, nxadr + 8, msksz, 1)
296  else
298   nmsz  = ENRLE(mskadr, nxadr + 8, msksz, rlesz)
300  endif
302  if nmsz < 0: Tidy nmsz:                rem Doesnt compress
304  :
306  if alpha then:                         rem Set RLE header
308   poke$ nxadr, 'RLE1'
310  else
312   poke$ nxadr, 'RLE' & rlesz
314  endif
316  poke_l nxadr + 4, msksz
318  ctr% = ctr% || 128:                    rem Flag mask compressed
320  rlex = rlex + 8:                       rem Add room for header
322 endif
324 :
326 rem     Save sprite
328 poke$ tsp, peek$(spr, hdsz)
330 poke tsp + 3, ctr%:                     rem Blob and/or Pattern compressed
332 if patadr then
334  poke_l tsp + 12, 12:                   rem Offset to pattern..
336 else
338  poke_l tsp + 12, 0:                    rem ..unless none
340 endif
342 if mskadr then
344  if npsz then
346   poke_l tsp + 16, npsz + 16:           rem Offset to mask..
348  else
350   poke_l tsp + 16, 8:                   rem ..but no pattern => blob
352  endif
354 else
356  poke_l tsp + 16, 0:                    rem No mask
358 endif
360 :
362 sbytes_o ofn$, tsp, hdsz + npsz + nmsz + rlex
364 beep 2000, 2: Tidy 0:                   rem All ok!
366 :
368 :
370 rem + ************************************************************************ +
372 rem *<                             General Utils                              >*
374 rem + ************************************************************************ +
376 :
378 :
380 DEFine FuNction BTST%(flg%, btn%)
382 RETurn (2 ^ btn% && flg%) <> 0
384 END DEFine BTST%
386 :
388 :
390 def proc Tidy(er)
392 rechp spr
394 if er <> 0: beep 2000, 200:             rem Error: Burp
396 quit er
398 enddef Tidy
400 :
402 :
404 rem + ------------------------------------------------------------------------ +
406 rem |<                                Command Line                            >|
408 rem + ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ +
410 rem |                    Parses command line and sets defaults                 |
412 rem |                                                                          |
414 rem |  /F - Input file name                                                    |
416 rem |  /O - Output file name (optional)                                        |
418 rem |                                                                          |
420 rem | Dependencies: DETAB$                                                     |
422 rem | GLOBal quote$                                                            |
424 rem + ------------------------------------------------------------------------ +
426 rem | V0.01, pjw, 2019 Jul 01, base version                                    |
428 rem | V0.01, pjw, 2024 Sep 02, Spr2RLE version
430 rem + ------------------------------------------------------------------------ +
432 :
434 def fn GetCmd(cl$)
436 loc p%, t$(50)
438 :
440 if cl$ = '': ret -15
442 :
444 rem     Get input file name
446 ifn$ = Getent$("F")
448 if ifn$ = '' then
450  ifn$ = cl$
452  ofn$ = 'ram1_sprite_spr'
454 else
456  ofn$ = Getent$('O')
458  if ofn$ = '': ofn$ = 'ram1_sprite_spr'
460 endif
462 :
464 ret fop_in(ifn$)
466 enddef GetCmd
468 :
470 def fn Getent$(c$)
472 rem Caller's cl$, p%, t$
474 rem Given the character get the entry
476 rem /C [<spaces>] ["|'] <entry> ["|'] <space> | <space> /C+1 | <eol>
478 :
480 p% = '/' & c$ instr cl$
482 if p% = 0: ret ''
484 t$ = DETAB$(cl$(p% + 2 to len(cl$)))
486 p% = ' /' instr t$
488 if p% > 0: t$ = t$(1 to p%): else: p% = len(t$)
490 for p% = len(t$) to 1 step -1
492  if not t$(p%) instr ' /': exit p%
494 endfor p%
496 :
498 t$ = t$(1 to p%)
500 if len(t$) > 1 then
502  p% = t$(1) instr quote$
504  if p% then
506   if (t$(len(t$)) instr quote$) = p% then
508    t$ = t$(2 to len(t$) - 1)
510   endif: endif: endif
512 ret t$
514 enddef Getent$
516 :
518 :
